package Visual_DVM_2021.Passes.All;
import Common.Utils.Utils_;
import _VisualDVM.Current;
import Common.Visual.Windows.Dialog.Dialog;
import _VisualDVM.Global;
import _VisualDVM.GlobalData.Compiler.Compiler;
import _VisualDVM.GlobalData.Compiler.CompilerType;
import _VisualDVM.GlobalData.CompilerEnvironment.CompilerEnvironment;
import _VisualDVM.GlobalData.CompilerEnvironment.UI.CompilerEnvironmentsFields;
import Visual_DVM_2021.Passes.PassCode;
import Common.Passes.Pass;

import javax.swing.*;
import java.util.Vector;
public class PickCompilerEnvironmentsForTesting extends Pass<String> {
    Compiler compiler = null;
    //-
    @Override
    protected boolean canStart(Object... args) throws Exception {
        if (args[0] == null) {
            Log.Writeln_("Отсутствует текущий компилятор. Выбор переменных окружения недоступен.");
            return false;
        }
        target = "";
        compiler = Global.mainModule.getCompiler();
        if (!compiler.type.equals(CompilerType.dvm)) {
            Log.Writeln_("Выбор переменных окружения возможен только для DVM компилятора,");
            return false;
        }
        if (!(compiler.helpLoaded ||  Global.mainModule.getPass(PassCode.ShowCompilerHelp).Do(compiler, false)))
            return false;
        Dialog<String, CompilerEnvironmentsFields> dialog =
                new Dialog<String, CompilerEnvironmentsFields>(CompilerEnvironmentsFields.class) {
                    @Override
                    public void InitFields() {
                        compiler.environments.mountUI((JPanel) fields.getContent());
                        compiler.environments.ShowUI();
                    }
                    @Override
                    public boolean NeedsScroll() {
                        return false;
                    }
                    @Override
                    public void validateFields() {
                        for (CompilerEnvironment compilerEnv : compiler.environments.Data.values()) {
                            if (compilerEnv.isSelected() && compilerEnv.value.isEmpty())
                                Log.Writeln_("Отмеченная переменная " + compilerEnv.name + " предполагает непустое значение.");
                        }
                    }
                };
        return dialog.ShowDialog("Назначение переменных окружения");
    }
    @Override
    protected void body() throws Exception {
        Vector<String> envs = new Vector<>();
        for (CompilerEnvironment compilerEnv : compiler.environments.Data.values()) {
            if (compilerEnv.isSelected())
                envs.add(compilerEnv.name + "=" + Utils_.DQuotes(compilerEnv.value));
        }
        target = String.join(" ", envs);
    }
}
